<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: bmp3.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">bmp3.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Sensor driver for BMP3 sensor.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &quot;<a class="el" href="bmp3_8h_source.html">bmp3.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for bmp3.c:</div>
<div class="dyncontent">
<div class="center"><img src="bmp3_8c__incl.png" border="0" usemap="#bmp3_8c" alt=""/></div>
<map name="bmp3_8c" id="bmp3_8c">
<area shape="rect" title="Sensor driver for BMP3 sensor." alt="" coords="53,5,124,32"/>
<area shape="rect" href="bmp3_8h.html" title=" " alt="" coords="53,80,124,107"/>
<area shape="rect" href="bmp3__defs_8h.html" title="Sensor driver for BMP3 sensor." alt="" coords="35,155,142,181"/>
<area shape="rect" title=" " alt="" coords="5,229,76,256"/>
<area shape="rect" title=" " alt="" coords="101,229,175,256"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:aff608ffafb8ebd79b7a0251b75451fba"><td class="memItemLeft" align="right" valign="top"><a id="aff608ffafb8ebd79b7a0251b75451fba"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#aff608ffafb8ebd79b7a0251b75451fba">bmp3_init</a> (struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:aff608ffafb8ebd79b7a0251b75451fba"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API is the entry point. It performs the selection of I2C/SPI read mechanism according to the selected interface and reads the chip-id and calibration data of the sensor. <br /></td></tr>
<tr class="separator:aff608ffafb8ebd79b7a0251b75451fba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9e0c2cdecfdac8aa6ed4e35940f7ade7"><td class="memItemLeft" align="right" valign="top"><a id="a9e0c2cdecfdac8aa6ed4e35940f7ade7"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#a9e0c2cdecfdac8aa6ed4e35940f7ade7">bmp3_get_regs</a> (uint8_t reg_addr, uint8_t *reg_data, uint32_t len, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:a9e0c2cdecfdac8aa6ed4e35940f7ade7"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API reads the data from the given register address of the sensor. <br /></td></tr>
<tr class="separator:a9e0c2cdecfdac8aa6ed4e35940f7ade7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad02d16a9569a75f9df070348eb7cb1fe"><td class="memItemLeft" align="right" valign="top"><a id="ad02d16a9569a75f9df070348eb7cb1fe"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#ad02d16a9569a75f9df070348eb7cb1fe">bmp3_set_regs</a> (uint8_t *reg_addr, const uint8_t *reg_data, uint32_t len, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:ad02d16a9569a75f9df070348eb7cb1fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API writes the given data to the register address of the sensor. <br /></td></tr>
<tr class="separator:ad02d16a9569a75f9df070348eb7cb1fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a53f320e8c5a13d452bc24dfc7de58a"><td class="memItemLeft" align="right" valign="top"><a id="a0a53f320e8c5a13d452bc24dfc7de58a"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#a0a53f320e8c5a13d452bc24dfc7de58a">bmp3_set_sensor_settings</a> (uint32_t desired_settings, struct <a class="el" href="structbmp3__settings.html">bmp3_settings</a> *settings, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:a0a53f320e8c5a13d452bc24dfc7de58a"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API sets the power control(pressure enable and temperature enable), over sampling, ODR and filter settings in the sensor. <br /></td></tr>
<tr class="separator:a0a53f320e8c5a13d452bc24dfc7de58a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae7bbd9da06309195baa80bdc5d8579fe"><td class="memItemLeft" align="right" valign="top"><a id="ae7bbd9da06309195baa80bdc5d8579fe"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#ae7bbd9da06309195baa80bdc5d8579fe">bmp3_get_sensor_settings</a> (struct <a class="el" href="structbmp3__settings.html">bmp3_settings</a> *settings, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:ae7bbd9da06309195baa80bdc5d8579fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API gets the power control(power mode, pressure enable and temperature enable), over sampling, ODR, filter, interrupt control and advance settings from the sensor. <br /></td></tr>
<tr class="separator:ae7bbd9da06309195baa80bdc5d8579fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a196d41429d31ad38ede321f3f0469a9d"><td class="memItemLeft" align="right" valign="top"><a id="a196d41429d31ad38ede321f3f0469a9d"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#a196d41429d31ad38ede321f3f0469a9d">bmp3_set_fifo_settings</a> (uint16_t desired_settings, const struct <a class="el" href="structbmp3__fifo__settings.html">bmp3_fifo_settings</a> *fifo_settings, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:a196d41429d31ad38ede321f3f0469a9d"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API sets the fifo_config_1(fifo_mode, fifo_stop_on_full, fifo_time_en, fifo_press_en, fifo_temp_en), fifo_config_2(fifo_subsampling, data_select) and int_ctrl(fwtm_en, ffull_en) settings in the sensor. <br /></td></tr>
<tr class="separator:a196d41429d31ad38ede321f3f0469a9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa228957bccd99f5f684d6feb5a9431c8"><td class="memItemLeft" align="right" valign="top"><a id="aa228957bccd99f5f684d6feb5a9431c8"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#aa228957bccd99f5f684d6feb5a9431c8">bmp3_get_fifo_settings</a> (struct <a class="el" href="structbmp3__fifo__settings.html">bmp3_fifo_settings</a> *fifo_settings, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:aa228957bccd99f5f684d6feb5a9431c8"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API gets the fifo_config_1(fifo_mode, fifo_stop_on_full, fifo_time_en, fifo_press_en, fifo_temp_en), fifo_config_2(fifo_subsampling, data_select) and int_ctrl(fwtm_en, ffull_en) settings from the sensor. <br /></td></tr>
<tr class="separator:aa228957bccd99f5f684d6feb5a9431c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f59707f3f65e257873d1309f38f17c9"><td class="memItemLeft" align="right" valign="top"><a id="a6f59707f3f65e257873d1309f38f17c9"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#a6f59707f3f65e257873d1309f38f17c9">bmp3_get_fifo_data</a> (struct <a class="el" href="structbmp3__fifo__data.html">bmp3_fifo_data</a> *fifo, const struct <a class="el" href="structbmp3__fifo__settings.html">bmp3_fifo_settings</a> *fifo_settings, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:a6f59707f3f65e257873d1309f38f17c9"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API gets the fifo data from the sensor. <br /></td></tr>
<tr class="separator:a6f59707f3f65e257873d1309f38f17c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ff60e43b4a740e2b6f2a59cdce0b4b9"><td class="memItemLeft" align="right" valign="top"><a id="a4ff60e43b4a740e2b6f2a59cdce0b4b9"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#a4ff60e43b4a740e2b6f2a59cdce0b4b9">bmp3_set_fifo_watermark</a> (const struct <a class="el" href="structbmp3__fifo__data.html">bmp3_fifo_data</a> *fifo, const struct <a class="el" href="structbmp3__fifo__settings.html">bmp3_fifo_settings</a> *fifo_settings, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:a4ff60e43b4a740e2b6f2a59cdce0b4b9"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API sets the fifo watermark length according to the frames count set by the user in the device structure. Refer below for usage. <br /></td></tr>
<tr class="separator:a4ff60e43b4a740e2b6f2a59cdce0b4b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a428e176513438c29000781c61f334296"><td class="memItemLeft" align="right" valign="top"><a id="a428e176513438c29000781c61f334296"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#a428e176513438c29000781c61f334296">bmp3_get_fifo_watermark</a> (uint16_t *watermark_len, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:a428e176513438c29000781c61f334296"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API sets the fifo watermark length according to the frames count set by the user in the device structure. Refer below for usage. <br /></td></tr>
<tr class="separator:a428e176513438c29000781c61f334296"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab3a00fc5971c5196e2fbbb03a428aea5"><td class="memItemLeft" align="right" valign="top"><a id="ab3a00fc5971c5196e2fbbb03a428aea5"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#ab3a00fc5971c5196e2fbbb03a428aea5">bmp3_extract_fifo_data</a> (struct <a class="el" href="structbmp3__data.html">bmp3_data</a> *data, struct <a class="el" href="structbmp3__fifo__data.html">bmp3_fifo_data</a> *fifo, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:ab3a00fc5971c5196e2fbbb03a428aea5"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API extracts the temperature and/or pressure data from the FIFO data which is already read from the fifo. <br /></td></tr>
<tr class="separator:ab3a00fc5971c5196e2fbbb03a428aea5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a61fadb14757875e006860607719e47f0"><td class="memItemLeft" align="right" valign="top"><a id="a61fadb14757875e006860607719e47f0"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#a61fadb14757875e006860607719e47f0">bmp3_get_status</a> (struct <a class="el" href="structbmp3__status.html">bmp3_status</a> *status, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:a61fadb14757875e006860607719e47f0"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API gets the command ready, data ready for pressure and temperature and interrupt (fifo watermark, fifo full, data ready) and error status from the sensor. <br /></td></tr>
<tr class="separator:a61fadb14757875e006860607719e47f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae11b6673c9cf7e6da640712c183ed2e7"><td class="memItemLeft" align="right" valign="top"><a id="ae11b6673c9cf7e6da640712c183ed2e7"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#ae11b6673c9cf7e6da640712c183ed2e7">bmp3_get_fifo_length</a> (uint16_t *fifo_length, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:ae11b6673c9cf7e6da640712c183ed2e7"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API gets the fifo length from the sensor. <br /></td></tr>
<tr class="separator:ae11b6673c9cf7e6da640712c183ed2e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad83b435b6be380ec33d48b5b84a068b1"><td class="memItemLeft" align="right" valign="top"><a id="ad83b435b6be380ec33d48b5b84a068b1"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#ad83b435b6be380ec33d48b5b84a068b1">bmp3_soft_reset</a> (struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:ad83b435b6be380ec33d48b5b84a068b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API performs the soft reset of the sensor. <br /></td></tr>
<tr class="separator:ad83b435b6be380ec33d48b5b84a068b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abe254ed403bc857b64db09c771f6b83e"><td class="memItemLeft" align="right" valign="top"><a id="abe254ed403bc857b64db09c771f6b83e"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#abe254ed403bc857b64db09c771f6b83e">bmp3_fifo_flush</a> (struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:abe254ed403bc857b64db09c771f6b83e"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API performs the soft reset of the sensor. <br /></td></tr>
<tr class="separator:abe254ed403bc857b64db09c771f6b83e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a47d3b5b195ea0155ff037fdf7f1ad527"><td class="memItemLeft" align="right" valign="top"><a id="a47d3b5b195ea0155ff037fdf7f1ad527"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#a47d3b5b195ea0155ff037fdf7f1ad527">bmp3_set_op_mode</a> (struct <a class="el" href="structbmp3__settings.html">bmp3_settings</a> *settings, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:a47d3b5b195ea0155ff037fdf7f1ad527"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API sets the power mode of the sensor. <br /></td></tr>
<tr class="separator:a47d3b5b195ea0155ff037fdf7f1ad527"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab06f63f2fc075f9d40bd0a16d42fda5"><td class="memItemLeft" align="right" valign="top"><a id="aab06f63f2fc075f9d40bd0a16d42fda5"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#aab06f63f2fc075f9d40bd0a16d42fda5">bmp3_get_op_mode</a> (uint8_t *op_mode, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:aab06f63f2fc075f9d40bd0a16d42fda5"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API gets the power mode of the sensor. <br /></td></tr>
<tr class="separator:aab06f63f2fc075f9d40bd0a16d42fda5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8b7c253abd6cd44aa260578a10395697"><td class="memItemLeft" align="right" valign="top"><a id="a8b7c253abd6cd44aa260578a10395697"></a>
int8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp3_8c.html#a8b7c253abd6cd44aa260578a10395697">bmp3_get_sensor_data</a> (uint8_t sensor_comp, struct <a class="el" href="structbmp3__data.html">bmp3_data</a> *comp_data, struct <a class="el" href="structbmp3__dev.html">bmp3_dev</a> *dev)</td></tr>
<tr class="memdesc:a8b7c253abd6cd44aa260578a10395697"><td class="mdescLeft">&#160;</td><td class="mdescRight">This API reads the pressure, temperature or both data from the sensor, compensates the data and store it in the <a class="el" href="structbmp3__data.html" title="bmp3 sensor structure which comprises of temperature and pressure data.">bmp3_data</a> structure instance passed by the user. <br /></td></tr>
<tr class="separator:a8b7c253abd6cd44aa260578a10395697"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Sensor driver for BMP3 sensor. </p>
<p>Copyright (c) 2020 Bosch Sensortec GmbH. All rights reserved.</p>
<p>BSD-3-Clause</p>
<p>Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:</p>
<ol type="1">
<li>Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.</li>
<li>Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.</li>
<li>Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.</li>
</ol>
<p>THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</p>
<dl class="section date"><dt>Date</dt><dd>2021-06-17 </dd></dl>
<dl class="section version"><dt>Version</dt><dd>v2.0.5</dd></dl>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
